export type MIoTSpec = { name: string; siid: number, piid: number }
export type MIoTSpecs = MIoTSpec[]
export type MIoTSpecMapping = { [name: string]: MIoTSpec }
export type MIoTSpecGetQuery = MIoTSpec & { did: string }
export type MIoTSpecsGetQuery = MIoTSpecGetQuery[]
export type MIoTSpecSetQuery = MIoTSpec & { did: string; value: any }
export type MIoTSpecsSetQuery = MIoTSpecSetQuery[]
export type MIoTSpecsResponse<T> = MIoTSpec & { did: string; value: T }
export type MIoTSpecsResponseMapping = { [name: string]: MIoTSpecsResponse<any> }
export type MIoTSpecsResponseValueMapping = { [name: string]: any }
export type MIoTDeviceIdentify = { name: string; token: string; address: string; }

export type MIIOSpec = string
export type MIIOSpecMapping = { [name: string]: MIIOSpec }
export type MIIOSpecGetQuery = MIIOSpec[]
export type MIIOSpecResponse = (string | number)[]
export type MIIOSpecResponseValueMapping = { [name: string]: any }

export type DeviceConfig = { name: string; address: string; token: string; }
export type DeviceConfigs = DeviceConfig[]

export class DeviceInstance {
  public id: string
  public did: string
  public timeout: number

  // MIoT
  public miioCall<T extends any> (action: 'get_properties', specQuery: MIoTSpecsGetQuery): MIoTSpecsResponse<T>[]
  public miioCall<T extends any> (action: 'set_properties', specQuery: MIoTSpecsSetQuery): MIoTSpecsResponse<T>[]
  // MIIO
  public miioCall<T extends any> (action: 'get_prop', specQuery: MIIOSpecGetQuery): MIIOSpecResponse
  public miioCall<T extends any> (action: string, specQuery: (string | number)[]): any
}
